function generic_dl(x)
{
  var y_=this.f_(x);
  return Math.sqrt(1+y_*y_);
}

function cos_f(x)
{
  return this.yplus+(x+this.xplus)*this.gradient+this.amplitude*Math.cos((x+this.xplus)*this.compression);
}

function cos_f_(x)
{
  return this.gradient-this.amplitude*this.compression*Math.sin((x+this.xplus)*this.compression);
}

function cos_f__(x)
{
  return -this.amplitude*this.compression*this.compression*Math.cos((x+this.xplus)*this.compression);
}

function line_f(x)
{
  return this.yplus+x*this.gradient;
}

function line_f_(x)
{
  return this.gradient;
}

function line_f__(x)
{
  return 0;
}

function Cosinus(amplitude,compression,gradient,xplus,yplus)
{
  this.amplitude=amplitude;
  this.compression=compression;
  this.gradient=gradient;
  this.xplus=xplus;
  this.yplus=yplus;
  this.wavelen=Math.abs(Math.PI*2.0/compression);
  if (!this.f)
  {
    this.f=cos_f;
    this.f_=cos_f_;
    this.f__=cos_f__;
    this.dl=generic_dl;
  }
}

function Line(gradient,yplus)
{
  this.gradient=gradient;
  this.yplus=yplus;
  this.wavelen=0;
  if (!this.f)
  {
    this.f=line_f;
    this.f_=line_f_;
    this.f__=line_f__;
    this.dl=generic_dl;
  }
}

function FitCosinus(lgradient,rgradient,minwarp)
{
  if (rgradient==lgradient)
  {
    this.Line=Line;
    this.Line(lgradient,0);
    delete this.Line;
  }
  else
  {
    var gradient=(lgradient+rgradient)*0.5;
    var warp=Math.abs(minwarp);
    if (rgradient>lgradient)
    {
      warp=-warp;
    }
    var m=lgradient-gradient;
    var compression=warp/m;
    var amplitude=m/compression;
    this.fit=FitCosinus;
    this.Cosinus=Cosinus;
    this.Cosinus(amplitude,compression,gradient,0,0);
    delete this.Cosinus;
  }
}
