var svgns="http://www.w3.org/2000/svg";

function _koordinatensystem_a_von_x(x)
{
  return this.f_breite*(1.0*x-this.x_min)+this.rand_links;
}

function _koordinatensystem_x_von_a(a)
{
  return this.q_breite*(a-this.rand_links)+this.x_min;
}

function _koordinatensystem_b_von_y(y)
{
  return this.rand_oben+this.hoehe-this.f_hoehe*(1.0*y-this.y_min);
}

function _koordinatensystem_y_von_b(b)
{
  return this.y_min-this.q_hoehe*(b-this.rand_oben-this.hoehe);
}

function _koordinatensystem_funktion_f(funktion,x_min,x_max,style)
{
  var punkte="";
  if (x_max<x_min)
  {
    var foo=x_min;
    x_min=x_max;
    x_max=foo;
  }
  if (x_min<this.x_min)
  {
    x_min=this.x_min;
    if (x_max<x_min)
    {
      x_max=x_min;
    }
  }
  if (x_max>this.x_max)
  {
    x_max=this.x_max;
    if (x_min>x_max)
    {
      x_min=x_max;
    }
  }
  var a_min=Math.round(this.a_von_x(x_min));
  var a_max=Math.round(this.a_von_x(x_max));
  for (var a=a_min;a<=a_max;a++)
  {
    var x=this.x_von_a(a);
    var b=this.b_von_y(funktion.f(x));
    punkte+=a+","+b+" ";
  }
  this._line(punkte,style)
}

function _koordinatensystem_funktion_f_ortho(funktion,y_min,y_max,style)
{
  var punkte="";
  if (y_max<y_min)
  {
    var foo=y_min;
    y_min=y_max;
    y_max=foo;
  }
  if (y_min<this.y_min)
  {
    y_min=this.y_min;
    if (y_max<y_min)
    {
      y_max=y_min;
    }
  }
  if (y_max>this.y_max)
  {
    y_max=this.y_max;
    if (y_min>y_max)
    {
      y_min=y_max;
    }
  }
  var b_min=Math.round(this.b_von_y(y_min));
  var b_max=Math.round(this.b_von_y(y_max));
  for (var b=b_min;b<=b_max;b++)
  {
    var y=this.y_von_b(b);
    var a=this.a_von_x(funktion.f(y));
    punkte+=a+","+b+" ";
  }
  this._line(punkte,style)
}

function _koordinatensystem_funktion_r(funktion,tau_plus,tau_min,tau_max,n_p,style)
{
  var punkte="";
  if (tau_max<tau_min)
  {
    var foo=tau_min;
    tau_min=tau_max;
    tau_max=foo;
  }
  var delta_tau=(tau_max-tau_min)/n_p;
  for (var n=0;n<=n_p;n++)
  {
    var tau=tau_min+(delta_tau*n);
    var r=funktion.r(tau);
    var a=this.a_von_x(Math.sin(tau+tau_plus)*r);
    var b=this.b_von_y(Math.cos(tau+tau_plus)*r);
    punkte+=a+","+b+" ";
  }
  this._line(punkte,style)
}

function _koordinatensystem_funktion_punkt(funktion,l_min,l_max,n_l,style)
{
  var punkte="";
  if (l_max<l_min)
  {
    var foo=l_min;
    l_min=l_max;
    l_max=foo;
  }
  var delta_l=(l_max-l_min)/n_l;
  for (var n=0;n<=n_p;n++)
  {
    var l=l_min+(delta_l*n);
    var punkt=funktion.punkt(l);
    var a=this.a_von_x(punkt.x);
    var b=this.b_von_y(punkt.y);
    punkte+=a+","+b+" ";
  }
  this._line(punkte,style)
}

function _koordinatensystem_senkrechte(x,style)
{
  var line=document.createElementNS(svgns,"line");
  line.setAttributeNS(null,"x1",this.a_von_x(x));
  line.setAttributeNS(null,"y1",this.rand_oben);
  line.setAttributeNS(null,"x2",this.a_von_x(x));
  line.setAttributeNS(null,"y2",this.rand_oben+this.hoehe);
  line.setAttributeNS(null,"style",style);
  this.svg.appendChild(line);
}

function _koordinatensystem_waagerechte(y,style)
{
  var line=document.createElementNS(svgns,"line");
  line.setAttributeNS(null,"x1",this.rand_links);
  line.setAttributeNS(null,"y1",this.b_von_y(y));
  line.setAttributeNS(null,"x2",this.rand_links+this.breite);
  line.setAttributeNS(null,"y2",this.b_von_y(y));
  line.setAttributeNS(null,"style",style);
  this.svg.appendChild(line);
}

function _koordinatensystem_kreis(r,n_p,style)
{
  var punkte="";
  var delta_tau=(Math.PI*2.0)/n_p;
  for (var n=0;n<=n_p;n++)
  {
    var tau=-Math.PI+(delta_tau*n);
    var a=this.a_von_x(Math.sin(tau)*r);
    var b=this.b_von_y(Math.cos(tau)*r);
    punkte+=a+","+b+" ";
  }
  this._line(punkte,style)
}

function _koordinatensystem_polylinie(points,style)
{
  var punkte="";
  var n_p=points.length;
  for (var n=0;n<n_p;n++)
  {
    var a=this.a_von_x(points[n].x);
    var b=this.b_von_y(points[n].y);
    punkte+=a+","+b+" ";
  }
  this._line(punkte,style)
}

function _koordinatensystem_gerade(x1,y1,x2,y2,style)
{
  var punkte="";
  {
    var a=this.a_von_x(x1);
    var b=this.b_von_y(y1);
    punkte+=a+","+b+" ";
  }
  {
    var a=this.a_von_x(x2);
    var b=this.b_von_y(y2);
    punkte+=a+","+b+" ";
  }
  this._line(punkte,style)
}

function _koordinatensystem__line(punkte,style)
{
  var poly1ine=document.createElementNS(svgns,"polyline");
  poly1ine.setAttributeNS(null,"points",punkte);
  poly1ine.setAttributeNS(null,"style",style);
  this.svg.appendChild(poly1ine);
}

function Koordinatensystem(x_min,x_max,y_min,y_max,breite,hoehe,rand_links,rand_oben,rand_rechts,rand_unten)
{
  this.x_min=1.0*x_min;
  this.x_max=1.0*x_max;
  this.y_min=1.0*y_min;
  this.y_max=1.0*y_max;
  this.x_laenge=this.x_max-this.x_min;
  this.y_laenge=this.y_max-this.y_min;
  this.breite=breite;
  this.hoehe=hoehe;
  this.f_breite=1.0*this.breite/this.x_laenge;
  this.f_hoehe=1.0*this.hoehe/this.y_laenge;
  this.q_breite=this.x_laenge/this.breite;
  this.q_hoehe=this.y_laenge/this.hoehe;
  this.rand_links=rand_links;
  this.rand_oben=rand_oben;
  this.rand_rechts=rand_rechts;
  this.rand_unten=rand_unten;
  this.gesamtbreite=this.rand_links+this.breite+1+this.rand_rechts;
  this.gesamthoehe=this.rand_oben+this.hoehe+1+this.rand_unten;
  this.a_von_x=_koordinatensystem_a_von_x;
  this.x_von_a=_koordinatensystem_x_von_a;
  this.b_von_y=_koordinatensystem_b_von_y;
  this.y_von_b=_koordinatensystem_y_von_b;
  this.funktion_f=_koordinatensystem_funktion_f;
  this.funktion_f_ortho=_koordinatensystem_funktion_f_ortho;
  this.funktion_r=_koordinatensystem_funktion_r;
  this.funktion_punkt=_koordinatensystem_funktion_punkt;
  this.senkrechte=_koordinatensystem_senkrechte;
  this.waagerechte=_koordinatensystem_waagerechte;
  this.kreis=_koordinatensystem_kreis;
  this.polylinie=_koordinatensystem_polylinie;
  this.gerade=_koordinatensystem_gerade;
  this._line=_koordinatensystem__line;
  this.svg=document.createElementNS(svgns,"svg");
  this.svg.setAttributeNS(null,"width",this.gesamtbreite);
  this.svg.setAttributeNS(null,"height",this.gesamthoehe);
  this.element=this.svg;
}
